local f = CreateFrame'Frame'
f:RegisterEvent'PLAYER_ENTERING_WORLD'
f:RegisterEvent'CVAR_UPDATE'

local UpdateAutoLootStatus = function(value)
	if tonumber(value) == 1 then
		f:RegisterEvent'LOOT_OPENED'
	else
		f:UnregisterEvent'LOOT_OPENED'
	end
end

IsAutoLootKeyDown = function()
	-- Possible values: ALT, CTRL, SHIFT, NONE
	local key = InterfaceOptionsControlsPanelAutoLootKeyDropDown:GetValue()
	if key ~= 'NONE' then
		if key == 'CTRL' then key = 'CONTROL' end
		local first, rest = key:sub(1, 1), key:sub(2):lower()
		return _G[('Is%s%sKeyDown'):format(first, rest)]()
	end
end

f:SetScript('OnEvent', function(self, event, ...)
	if event == 'PLAYER_ENTERING_WORLD' then
		UpdateAutoLootStatus(GetCVar'autoLootDefault')
	elseif event == 'CVAR_UPDATE' then
		local glStr, value = ...
		if glStr == 'AUTO_LOOT_DEFAULT_TEXT' then
			UpdateAutoLootStatus(value)
		end
	elseif event == 'LOOT_OPENED' then
		-- LOOT_OPENED's first argument is whether the contents should be auto loot - 1 for yes, 0 for no.
		-- We know it's bugged when the auto loot option is enabled but a 0 is received.
		--
		-- Caveat:
		--	If we hold down the auto loot key with auto loot enabled, it should not be looted, and it will send a 0.
		--	Our custom function lets the user keep acute control over auto loot while still fixing the bug when it should.
		
		local shouldAutoLoot = ...
		if shouldAutoLoot == 0 and not IsAutoLootKeyDown() then
			--print'autoLoot bugged'
			for i = 1, GetNumLootItems() do
				LootSlot(i)
			end
		end
	end
end)